#include "C:\GoAsm\IncludeA\WINDOWS.inc"
#include "C:\GoAsm\IncludeA\all_api.inc"

;eventvwr.msc

;#include "\RadASM\GoAsm\inc\debug.a"
;DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
;DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists

.CONST
	TOPMSG			equ	2048
	IDD_DLG1		equ	1000
	MINSPLIT		equ	20
	MAXSPLIT		equ	80
	IDC_SPLITTER	equ	1500
	CMD_SAVE		equ	2000
	CMD_OPT			equ	2001
	CMD_CLEAR		equ	2002
	CMD_EVENT		equ	2003

	IDR_SPLITCUR	equ	5000
	IDR_TBBITMAP	equ	5001
	MINWIDTH		equ	400
	MINHEIGHT		equ	300

.DATA
	icc	 			DQ	3FFF00000008h
	LBRatio			DD	40

	DrWRegKey		DB	"SOFTWARE\Microsoft\DrWatson",0
	DrWnExcp		DB	"MaximumCrashes",0
	DrWPath			DB	"LogFilePath",0
	AppFindStr		DB	"Application exception occurred:",0
	SysiFindStr		DB	"*----> System Information <----*",0
	TaskFindStr		DB	"*----> Task List <----*",0
	StateFindStr	DB	"State Dump for Thread Id ",0
	StackFindStr	DB	"*----> Stack Back Trace <----*",0
	RawFindStr		DB	"*----> Raw Stack Dump <----*",0
	FaultFindStr	DB	"FAULT ->",0
	LBFormat		DB	"Log %u - %s"

	DrWatMain		DB	"C:\WINNT\system32\DRWTSN32.EXE",0 
	DrWatConfig		DB	"DrWatsonDialog",0
	AboutMsg		DB	"RadASM RichEdit editor',13,10,'KetilO (C) 2002",0
	AppName			DB	"Dr Watson log viewer addin",0
	OpenFileFail	DB	"Cannot open the file",0
	SaveFileFail	DB	"Cannot save the file",0

	ALIGN 16
	DisplayFont		LOGFONT	<-13,0,0,0,FW_NORMAL,FALSE,FALSE,0,0,0,0,0,0,"Courier New">
	
	Arial_Black_10 LOGFONT <-13,0,0,0,400,255,1,1,0,3,2,1,34,"Arial Black">
	Teminator		DB	0

	szTBBtns		DB	"Save",0
					DB	"Config",0
					DB	"Clear",0
					DB	"Event Log",0,0

	ALIGN 16
	tbrbtns			TBBUTTON	<0,CMD_SAVE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
					TBBUTTON	<1,CMD_OPT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,1,1>
					TBBUTTON	<2,CMD_CLEAR,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,2,2>
					TBBUTTON	<3,CMD_EVENT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,3,3>

	tbbend:
	nToolbarBtns	equ	(tbbend-tbrbtns) /SIZEOF TBBUTTON

	hDispFont		DD	?
	hIml			DD	?

	MsgTable		DD	TOPMSG DUP (?)
	hInstance		DD 	?
	hREd			DD	?
	hWnd			DD	?
	hToolbar		DD	?
	hListbox		DD	?
	DrWatID			DD	?
	DrWLogFile		DB	MAX_PATH DUP (?)
	TextBuffer		DB	MAX_PATH DUP (?)
	FileName		DB	MAX_PATH dup (?)
	IsMoving		DD	?
	IsSizing		DD	?
	hDivBar			DD	?
	frect			RECT <?>

.CODE
; Just touch the IID of ITextHost2, that will force RichEd20.dll to load
; no need to ever execute this, it is only to have the DLL loaded with the app
mov eax,[IID_ITextHost2]

BuildMessageTable:
	uses edi,ecx,eax
		; Set the default proc for all messages to WM_USER+1023
		mov edi,OFFSET MsgTable
		mov ecx,TOPMSG-1
		mov eax,OFFSET DEFPROC
		rep stosd
		; Set the offsets of the messages to process
		mov [MsgTable+(WM_INITDIALOG *4)],OFFSET WMINITDIALOG
		mov [MsgTable+(WM_COMMAND *4)],OFFSET WMCOMMAND
		mov [MsgTable+(WM_CLOSE *4)],OFFSET WMCLOSE
		mov [MsgTable+(WM_WINDOWPOSCHANGED *4)],OFFSET WMWINDOWPOSCHANGED
		mov [MsgTable+(WM_GETMINMAXINFO *4)],OFFSET WMGETMINMAXINFO
		mov [MsgTable+(WM_ENTERSIZEMOVE *4)],OFFSET WMENTERSIZEMOVE
		mov [MsgTable+(WM_EXITSIZEMOVE *4)],OFFSET WMEXITSIZEMOVE
		mov [MsgTable+(WM_ERASEBKGND *4)],OFFSET WMERASEBKGND
		mov [MsgTable+(WM_LBUTTONUP *4)],OFFSET WMLBUTTONUP
		mov [MsgTable+(WM_MOUSEMOVE *4)],OFFSET WMMOUSEMOVE
		ret
	endu

SetupToolbar:
	invoke SendMessage,[hToolbar],TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
	invoke ImageList_LoadImage,[hInstance],IDR_TBBITMAP,16,16,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	mov [hIml],eax
	invoke ImageList_SetBkColor,[hIml],CLR_NONE
	invoke ImageList_SetBkColor,[hIml],CLR_NONE
	invoke SendMessage,[hToolbar],TB_SETIMAGELIST,0,[hIml]
	invoke SendMessage,[hToolbar],TB_SETINDENT,8,0
	invoke SendMessage,[hToolbar],TB_ADDBUTTONS,nToolbarBtns,OFFSET tbrbtns
	invoke SendMessage,[hToolbar],TB_ADDSTRING,NULL,OFFSET szTBBtns
	invoke SendMessage,[hToolbar],TB_AUTOSIZE,0,0
	RET

InitSplitterClass FRAME
	LOCAL wcx		:WNDCLASSEX

	mov D[wcx.cbSize],SIZEOF WNDCLASSEX
	mov D[wcx.style], CS_HREDRAW + CS_VREDRAW
	mov eax,[hInstance]
	mov D[wcx.hInstance],eax
	mov D[wcx.lpszClassName],OFFSET UDC_SplitterClass
	mov D[wcx.cbClsExtra],0
	mov D[wcx.cbWndExtra],0
	mov D[wcx.lpfnWndProc],OFFSET SplitterProc
	mov D[wcx.hIcon],NULL
	mov D[wcx.hIconSm],NULL
	mov D[wcx.hbrBackground],COLOR_BTNFACE+1 ;eax
	mov D[wcx.lpszMenuName],NULL

	mov eax,[hDivBar]
	mov [wcx.hCursor],eax

	invoke RegisterClassEx,ADDR wcx

	ret

	UDC_SplitterClass:	DB		"UDC_Splitter",0

ENDF

Start:
	call BuildMessageTable
	invoke GetModuleHandle, 0
	mov [hInstance],eax

	invoke CreateFontIndirect,OFFSET DisplayFont
	mov [hDispFont],eax

	invoke LoadCursor,[hInstance],IDR_SPLITCUR
	mov [hDivBar],eax

	invoke InitCommonControlsEx,OFFSET icc

	invoke InitSplitterClass

	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx,esi,edi
	LOCAL cf		:CHARFORMAT
	LOCAL chrg		:CHARRANGE
	LOCAL rect		:RECT
	LOCAL pt		:POINT

	mov eax,[uMsg]
	cmp eax,TOPMSG-1
	ja >DEFPROC
	jmp [MsgTable+eax*4]

	WMINITDIALOG:
		mov eax,[hwnd]
		mov [hWnd],eax
		invoke GetDlgItem,[hwnd],1001
		mov [hREd],eax
		invoke GetDlgItem,[hwnd],1002
		mov [hListbox],eax
		invoke GetDlgItem,[hwnd],1003
		mov [hToolbar],eax

		call SetupToolbar

		invoke GetLogLocation,OFFSET DrWLogFile
		invoke lstrcat,OFFSET DrWLogFile,"\drwtsn32.log"
		invoke GetFileAttributes,OFFSET DrWLogFile
		or eax,eax
		jns >
			invoke MessageBox,NULL,"No log file found",NULL,MB_OK
			invoke PostMessage,[hwnd],WM_CLOSE,0,0
			jmp >>.EXIT
		:
		invoke LoadFile,OFFSET DrWLogFile

		invoke SendMessage,[hREd],EM_HIDESELECTION,TRUE,0
		;Select all text
		mov D[chrg.cpMin],0
		mov D[chrg.cpMax],-1
		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET chrg

		mov D[cf.cbSize],SIZEOF CHARFORMAT
		mov D[cf.dwMask],CFM_CHARSET+CFM_FACE+CFM_SIZE+CFM_COLOR
		mov eax,[DisplayFont.lfHeight]
		; 9*16 = 144
		neg eax
		mov ecx,eax
		shl eax,4
		sub eax,ecx
		mov D[cf.yHeight],eax
		mov D[cf.crTextColor],0
		mov B[cf.bPitchAndFamily],0
		mov B[cf.bCharSet],0
		invoke lstrcpy,OFFSET cf.szFaceName,OFFSET DisplayFont.lfFaceName
		invoke SendMessage,[hREd],EM_SETCHARFORMAT,SCF_SELECTION,OFFSET cf

		;Remove selection
		mov D[chrg.cpMin],0
		mov D[chrg.cpMax],0
		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET chrg
		invoke FindErrorHeaders
		invoke SetControlSizes,40
		
		invoke SendMessage,[hREd],EM_HIDESELECTION,FALSE,0
		mov D[chrg.cpMin],-1
		mov	D[chrg.cpMax],-1
		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET chrg
		invoke SendDlgItemMessage,[hWnd],1002,LB_GETITEMDATA,0,0
		mov [chrg.cpMin],eax
		inc eax
		mov	[chrg.cpMax],eax
		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET chrg
		invoke SendMessage,[hREd],EM_HIDESELECTION,TRUE,0
		invoke SendMessage,[hListbox],LB_SETCURSEL,0,0
		xor eax,eax
		ret

	WMERASEBKGND:
		cmp D[IsMoving],TRUE
		jne >>DEFPROC
		xor eax,eax
		inc eax
		ret

	WMENTERSIZEMOVE:
		mov D[IsMoving],TRUE
		xor eax,eax
		ret

	WMEXITSIZEMOVE:
		mov D[IsMoving],FALSE
		invoke InvalidateRect,[hwnd],NULL,TRUE
		invoke UpdateWindow,[hwnd]
		xor eax,eax
		ret

	WMGETMINMAXINFO:
		mov edi,[lParam]
		mov D[edi+MINMAXINFO.ptMinTrackSize.x],MINWIDTH
		mov D[edi+MINMAXINFO.ptMinTrackSize.y],MINHEIGHT
		xor eax,eax
		ret

	WMCOMMAND:
		cmp W[wParam],1002
		jne >>M1
		cmp W[wParam+2],LBN_DBLCLK
		jne >>.EXIT
			invoke SendMessage,[hREd],EM_HIDESELECTION,FALSE,0
			mov D[chrg.cpMin],-1
			mov	D[chrg.cpMax],-1
			invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET chrg

			invoke SendMessage,[lParam],LB_GETCURSEL,0,0
			invoke SendMessage,[lParam],LB_GETITEMDATA,eax,0
			mov [chrg.cpMin],eax
			inc eax
			mov	[chrg.cpMax],eax
			invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET chrg
			invoke SendMessage,[hREd],EM_HIDESELECTION,TRUE,0

		M1:
		cmp W[wParam],CMD_OPT
		jne >>M2
			
			invoke CreateThread,NULL,NULL,OFFSET StartDrWatson,[hwnd],NULL,ADDR DrWatID
			invoke CloseHandle,eax

		M2:
		cmp W[wParam],CMD_SAVE
		jne >>M3
			invoke SaveEditAs

		M3:
		cmp W[wParam],CMD_CLEAR
		jne >>M4
			; OFFSET DrWLogFile
			invoke MessageBox,[hwnd],"Clear log ?","Clear",MB_YESNO
			cmp eax,IDYES
			jne >>.EXIT
			invoke DeleteFile,OFFSET DrWLogFile
			invoke CreateFile,OFFSET DrWLogFile,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL
			invoke PostMessage,[hwnd],WM_CLOSE,0,0
		
		M4:
		cmp W[wParam],CMD_EVENT
		jne >>.EXIT
			invoke CreateThread,NULL,NULL,OFFSET StartEventViewer,[hwnd],NULL,ADDR DrWatID
			invoke CloseHandle,eax

		jmp >>.EXIT

	WMWINDOWPOSCHANGED:
		invoke SetControlSizes,[LBRatio]
		jmp >>DEFPROC

	WMLBUTTONUP:
		cmp D[IsSizing],TRUE
		jne >>.EXIT
			invoke ReleaseCapture
			invoke ClipCursor,NULL

			invoke GetDlgItem,[hwnd],IDC_SPLITTER
			mov ebx,eax
			invoke SetClassLong,ebx,GCL_HBRBACKGROUND,COLOR_BTNFACE + 1 ;[hSplitBrush]
			invoke InvalidateRect,ebx,NULL,TRUE
			invoke UpdateWindow,ebx

			invoke GetDC,[hWnd]
			mov ebx,eax
			invoke DrawFocusRect,ebx,ADDR frect
			invoke ReleaseDC,[hWnd],ebx

			invoke GetWindowRect,[hWnd],ADDR rect
			invoke GetCursorPos,ADDR pt
			mov eax,[pt.x]
			sub eax,[rect.left]
			push eax
			invoke GetClientRect,[hwnd],ADDR rect
			pop eax
			mov ecx,[rect.right]
			mov edx,100
			mul edx
			xor edx,edx
			div ecx
			mov [LBRatio],eax
			invoke SetControlSizes,eax
			mov D[IsSizing],FALSE
			xor eax,eax
			ret

	WMMOUSEMOVE:
		cmp D[IsSizing],TRUE
		jne >>.EXIT
			invoke GetCursorPos,ADDR pt
			invoke ScreenToClient,[hWnd],ADDR pt
			invoke GetDC,[hWnd]
			mov ebx,eax
			invoke DrawFocusRect,ebx,ADDR frect
			mov eax,[pt.x]
			add eax,1
			mov [frect.right],eax
			invoke DrawFocusRect,ebx,ADDR frect
			invoke ReleaseDC,[hWnd],ebx
			xor eax,eax
			ret
			jmp >>.EXIT

	WMCLOSE:
		INVOKE EndDialog,[hwnd],0

	DEFPROC:
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

SplitterProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL rect	:RECT
	LOCAL pt	:POINT
	LOCAL ps	:PAINTSTRUCT

	cmp D[uMsg],WM_LBUTTONDOWN
	jne >>
		mov D[IsSizing],TRUE
			invoke SetCursor,[hDivBar]
			invoke SetCapture,[hWnd]
			
			invoke GetStockObject,BLACK_BRUSH
			invoke SetClassLong,[hwnd],GCL_HBRBACKGROUND,eax
			invoke InvalidateRect,[hwnd],NULL,TRUE
			invoke UpdateWindow,[hwnd]

			; Calculate the limits for right, left, top and bottom motion
			; the treeview can be a minimum of MINSPLIT% of the dlg size
			; the treeview can be a maximum of MAXSPLIT% of the dlg size
			; The cursor also should be confined to the vertical work area
			invoke GetClientRect,[hWnd],ADDR rect
			; find MINSPLIT
			mov eax,[rect.right]
			mov ecx,MINSPLIT
			mul	ecx
			mov ecx,100
			xor edx,edx
			div ecx
			push eax
			; find MAXSPLIT
			mov eax,[rect.right]
			mov ecx,MAXSPLIT
			mul	ecx
			mov ecx,100
			xor edx,edx
			div ecx
			push eax

			invoke GetWindowRect,[hListbox],ADDR rect
			invoke ScreenToClient,[hWnd],ADDR rect
			mov eax,[rect.top]
			invoke ScreenToClient,[hWnd],ADDR rect.right

			pop eax
			mov [rect.right],eax
			pop eax
			mov [rect.left],eax

			invoke ClientToScreen,[hWnd],ADDR rect
			invoke ClientToScreen,[hWnd],ADDR rect.right
			invoke ClipCursor,ADDR rect

			; Get the bounding rect of the treeview
			; relative to the dialog box
			invoke GetWindowRect,[hListbox],ADDR frect
			invoke ScreenToClient,[hWnd],ADDR frect
			invoke ScreenToClient,[hWnd],ADDR frect.right

			invoke GetCursorPos,ADDR pt
			invoke ScreenToClient,[hWnd],ADDR pt
			mov eax,[pt.x]
			inc eax
			mov D[frect.right],eax

			invoke GetDC,[hWnd]
			mov ebx,eax
			invoke DrawFocusRect,ebx,ADDR frect
			invoke ReleaseDC,[hWnd],ebx

			xor eax,eax
			ret
	:

	invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
	
	RET
ENDF

SetControlSizes FRAME ratio
	uses ebx
	LOCAL WinRect	:RECT
	LOCAL rect		:RECT
	LOCAL tbRect	:RECT
	LOCAL LBWidth	:D

	invoke GetWindowRect,[hListbox],OFFSET rect
	mov eax,[rect.right]
	sub eax,[rect.left]

	invoke GetWindowRect,[hToolbar],OFFSET tbRect
	mov ebx,[tbRect.bottom]
	sub ebx,[tbRect.top]
	invoke GetClientRect,[hWnd],OFFSET WinRect

	cmp D[IsSizing],FALSE
	je >T0
		mov eax,[WinRect.right]
		mul D[ratio]
		xor edx,edx
		mov ecx,100
		div ecx
		jmp >T1
	T0:
		invoke GetWindowRect,[hListbox],OFFSET rect
		mov eax,[rect.right]
		sub eax,[rect.left]
	T1:
	mov [LBWidth],eax

	mov D[rect.left],0
	mov D[rect.top],ebx
	mov eax,[LBWidth]
	mov D[rect.right],eax
	mov eax,[WinRect.bottom]
	sub eax,ebx
	mov [rect.bottom],eax
	invoke GetDlgItem,[hWnd],1002
	invoke MoveWindow,eax,[rect.left],[rect.top],[rect.right],[rect.bottom],TRUE


	mov ecx,[rect.right]
	mov D[rect.left],ecx
	mov D[rect.top],ebx
	mov D[rect.right],4
	mov eax,[WinRect.bottom]
	sub eax,ebx
	mov [rect.bottom],eax
	invoke GetDlgItem,[hWnd],1500
	invoke MoveWindow,eax,[rect.left],[rect.top],[rect.right],[rect.bottom],TRUE

	mov ecx,[LBWidth]
	add ecx,4
	mov D[rect.left],ecx
	mov D[rect.top],ebx
	mov eax,[WinRect.right]
	sub eax,ecx
	mov [rect.right],eax
	mov eax,[WinRect.bottom]
	sub eax,ebx
	mov [rect.bottom],eax
	invoke GetDlgItem,[hWnd],1001
	invoke MoveWindow,eax,[rect.left],[rect.top],[rect.right],[rect.bottom],TRUE

	invoke SendMessage,[hToolbar],TB_AUTOSIZE,0,0

	RET
ENDF

GetLogLocation FRAME pLogFilePath
	LOCAL hRegKey				:D
	LOCAL uDataCode				:D
	LOCAL cbRead				:D
	LOCAL hHeap					:D
	LOCAL DrWLogPath[MAX_PATH]	:B
	LOCAL pidl					:D

	invoke RegOpenKeyEx, HKEY_LOCAL_MACHINE, ADDR DrWRegKey, 0, KEY_READ, ADDR hRegKey
	or eax,eax
	jz >
		ret
	:

	mov D[cbRead],MAX_PATH
	invoke RegQueryValueEx,[hRegKey],OFFSET DrWPath,NULL,ADDR uDataCode,\
		OFFSET DrWLogPath,ADDR cbRead
	or eax,eax
	jnz >
		invoke lstrcpy,[pLogFilePath],OFFSET DrWLogPath
		jmp >.EXIT
	:
		invoke SHGetSpecialFolderLocation,NULL,02eh,offset pidl ;CSIDL_COMMON_DOCUMENTS
		invoke SHGetPathFromIDList,[pidl],[pLogFilePath]
		invoke lstrcat,[pLogFilePath],"\DrWatson"
		invoke SHELL32.DLL:155,[pidl] ; ILFree
	.EXIT

	invoke RegCloseKey,[hRegKey]
	RET
ENDF

FindErrorHeaders FRAME
	LOCAL ft			:FINDTEXTEX
	LOCAL pt			:POINT
	LOCAL cf			:CHARFORMAT
	LOCAL tr			:TEXTRANGE
	LOCAL buf[MAX_PATH]	:B
	LOCAL szAppPID[16]	:B
	LOCAL szExcept[128]	:B
	LOCAL iLog			:D

	mov D[szAppPID],"    "

	mov D[iLog],0
	L1:
	inc D[iLog]
	invoke SendMessage,[hREd],EM_EXGETSEL,0,offset ft.chrg
	mov ecx,[ft.chrg.cpMin]
	inc D[ft.chrg.cpMin]
	mov D[ft.chrg.cpMax],-1
	mov [ft.lpstrText],OFFSET AppFindStr
	invoke SendMessage,[hREd],EM_FINDTEXTEX,FR_DOWN,OFFSET ft
	or eax,eax
	js >>.EXIT
		mov ebx,[ft.chrgText.cpMin]
		invoke SendMessage,[hREd],EM_HIDESELECTION,FALSE,0

		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET ft.chrgText
		mov D[cf.cbSize],SIZEOF CHARFORMAT
		mov D[cf.dwMask],CFM_COLOR+CFM_BOLD
		mov D[cf.crTextColor],000000FFh
		mov D[cf.dwEffects],CFE_BOLD
		invoke SendMessage,[hREd],EM_SETCHARFORMAT,SCF_SELECTION,OFFSET cf

		mov eax,[ft.chrgText.cpMax]
		mov D[tr.chrg.cpMin],eax
		add eax,MAX_PATH
		dec eax
		mov D[tr.chrg.cpMax],eax
		lea eax,buf
		mov D[tr.lpstrText],eax
		invoke SendMessage,[hREd],EM_GETTEXTRANGE,0,OFFSET tr
		mov ecx,eax
		mov al,"="
		mov edi,OFFSET buf
		repne scasb
		mov esi,edi
		mov al,")"
		repne scasb
		mov B[edi-1],0
		
		push ecx
		invoke lstrcpyn,OFFSET szAppPID+4,esi,15
		pop ecx

		mov eax,"Exce"
		:
		cmp [edi],eax
		je >
			inc edi
			dec ecx
			or ecx,ecx
			jz >
			jmp <
		:
		mov al,":"
		repne scasb
		mov esi,edi
		mov al,")"
		repne scasb
		mov B[edi],0
		invoke lstrcpy,OFFSET szExcept,esi

		; Break down the component parts
		invoke SendMessage,[hREd],EM_EXGETSEL,0,offset ft.chrg
		inc D[ft.chrg.cpMin]
		mov D[ft.chrg.cpMax],-1
		mov [ft.lpstrText],OFFSET SysiFindStr
		invoke SendMessage,[hREd],EM_FINDTEXTEX,FR_DOWN,OFFSET ft

		or eax,eax
		js >

		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET ft.chrgText
		mov D[cf.cbSize],SIZEOF CHARFORMAT
		mov D[cf.dwMask],CFM_COLOR+CFM_BOLD
		mov D[cf.crTextColor],00FF0000h
		mov D[cf.dwEffects],CFE_BOLD
		invoke SendMessage,[hREd],EM_SETCHARFORMAT,SCF_SELECTION,OFFSET cf
		
		:

		invoke SendMessage,[hREd],EM_EXGETSEL,0,offset ft.chrg
		inc D[ft.chrg.cpMin]
		mov D[ft.chrg.cpMax],-1
		mov [ft.lpstrText],OFFSET TaskFindStr
		invoke SendMessage,[hREd],EM_FINDTEXTEX,FR_DOWN,OFFSET ft
		
		or eax,eax
		js >

		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET ft.chrgText
		mov D[cf.cbSize],SIZEOF CHARFORMAT
		mov D[cf.dwMask],CFM_COLOR+CFM_BOLD
		mov D[cf.crTextColor],00FF0000h
		mov D[cf.dwEffects],CFE_BOLD
		invoke SendMessage,[hREd],EM_SETCHARFORMAT,SCF_SELECTION,OFFSET cf

		:

		; Scan ahead for the PID in the task list
		invoke SendMessage,[hREd],EM_EXGETSEL,0,offset ft.chrg
		inc D[ft.chrg.cpMin]
		mov D[ft.chrg.cpMax],-1
		invoke lstrlen,OFFSET szAppPID+4
		mov ecx,eax
		lea eax,[szAppPID+ecx+4] ; append a space
		mov W[eax]," "
		lea eax,[szAppPID+ecx] ; pack with leading spaces
		mov [ft.lpstrText],eax
		invoke SendMessage,[hREd],EM_FINDTEXTEX,FR_DOWN,OFFSET ft

		mov eax,[ft.chrgText.cpMax]
		mov D[tr.chrg.cpMin],eax
		add eax,MAX_PATH
		dec eax
		mov D[tr.chrg.cpMax],eax
		lea eax,buf
		mov D[tr.lpstrText],eax
		invoke SendMessage,[hREd],EM_GETTEXTRANGE,0,OFFSET tr
		mov ecx,eax
		mov al," "
		mov edi,OFFSET buf
		repe scasb
		mov esi,edi
		dec esi
		mov al,13
		repne scasb
		mov B[edi-1],0

		invoke wsprintf,OFFSET TextBuffer,"LOG %u - %s Error 0x0%s",[iLog],esi,OFFSET szExcept+1
		add esp,20
		invoke SendDlgItemMessage,[hWnd],1002,LB_ADDSTRING,0,OFFSET TextBuffer ;esi
		invoke SendDlgItemMessage,[hWnd],1002,LB_SETITEMDATA,eax,ebx

		invoke SendMessage,[hREd],EM_EXGETSEL,0,offset ft.chrg
		inc D[ft.chrg.cpMin]
		mov D[ft.chrg.cpMax],-1
		mov [ft.lpstrText],OFFSET StateFindStr
		invoke SendMessage,[hREd],EM_FINDTEXTEX,FR_DOWN,OFFSET ft
		
		or eax,eax
		js >

		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET ft.chrgText
		mov D[cf.cbSize],SIZEOF CHARFORMAT
		mov D[cf.dwMask],CFM_COLOR+CFM_BOLD
		mov D[cf.crTextColor],00FF0000h
		mov D[cf.dwEffects],CFE_BOLD
		invoke SendMessage,[hREd],EM_SETCHARFORMAT,SCF_SELECTION,OFFSET cf
		
		:

		invoke SendMessage,[hREd],EM_EXGETSEL,0,offset ft.chrg
		inc D[ft.chrg.cpMin]
		mov D[ft.chrg.cpMax],-1
		mov [ft.lpstrText],OFFSET FaultFindStr
		invoke SendMessage,[hREd],EM_FINDTEXTEX,FR_DOWN,OFFSET ft
		
		or eax,eax
		js >

		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET ft.chrgText
		mov D[cf.cbSize],SIZEOF CHARFORMAT
		mov D[cf.dwMask],CFM_COLOR+CFM_BOLD
		mov D[cf.crTextColor],000000FFh
		mov D[cf.dwEffects],CFE_BOLD
		invoke SendMessage,[hREd],EM_SETCHARFORMAT,SCF_SELECTION,OFFSET cf
		
		:
		
		invoke SendMessage,[hREd],EM_EXGETSEL,0,offset ft.chrg
		inc D[ft.chrg.cpMin]
		mov D[ft.chrg.cpMax],-1
		mov [ft.lpstrText],OFFSET StackFindStr
		invoke SendMessage,[hREd],EM_FINDTEXTEX,FR_DOWN,OFFSET ft
		
		or eax,eax
		js >

		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET ft.chrgText
		mov D[cf.cbSize],SIZEOF CHARFORMAT
		mov D[cf.dwMask],CFM_COLOR+CFM_BOLD
		mov D[cf.crTextColor],00FF0000h
		mov D[cf.dwEffects],CFE_BOLD
		invoke SendMessage,[hREd],EM_SETCHARFORMAT,SCF_SELECTION,OFFSET cf
		
		:

		invoke SendMessage,[hREd],EM_EXGETSEL,0,offset ft.chrg
		inc D[ft.chrg.cpMin]
		mov D[ft.chrg.cpMax],-1
		mov [ft.lpstrText],OFFSET RawFindStr
		invoke SendMessage,[hREd],EM_FINDTEXTEX,FR_DOWN,OFFSET ft

		invoke SendMessage,[hREd],EM_EXSETSEL,0,OFFSET ft.chrgText
		mov D[cf.cbSize],SIZEOF CHARFORMAT
		mov D[cf.dwMask],CFM_COLOR+CFM_BOLD
		mov D[cf.crTextColor],00FF0000h
		mov D[cf.dwEffects],CFE_BOLD
		invoke SendMessage,[hREd],EM_SETCHARFORMAT,SCF_SELECTION,OFFSET cf

		invoke SendMessage,[hREd],EM_HIDESELECTION,TRUE,0
		jmp <<L1
		ret
	.EXIT
	RET
ENDF

LoadFile FRAME lpFileName
    LOCAL   hFile		:D
	LOCAL	editstream	:EDITSTREAM
	LOCAL	chrg		:CHARRANGE

	invoke CreateFile,[lpFileName],GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
	or eax,eax
	js >>
		mov [hFile],eax
		;Copy buffer to FileName
		invoke lstrcpy,offset FileName,[lpFileName]
		invoke SetWindowText,[hWnd],offset FileName
		;stream the text into the richedit control
		push [hFile]
		pop [editstream.dwCookie]
		mov [editstream.pfnCallback],offset StreamInProc
		invoke SendMessage,[hREd],EM_STREAMIN,SF_TEXT,addr editstream
		invoke CloseHandle,[hFile]
		invoke SendMessage,[hREd],EM_SETMODIFY,FALSE,0
		mov D[chrg.cpMin],0
		mov D[chrg.cpMax],0
		invoke SendMessage,[hREd],EM_EXSETSEL,0,addr chrg
		mov eax,FALSE
		ret
	:
		invoke MessageBox,[hWnd],offset OpenFileFail,offset AppName,MB_OK+MB_ICONERROR
		mov eax,TRUE
		ret
ENDF

StreamInProc FRAME hFile,pBuffer,NumBytes,pBytesRead

	invoke ReadFile,[hFile],[pBuffer],[NumBytes],[pBytesRead],0
	xor	eax,1
	ret

ENDF

StreamOutProc FRAME hFile,pBuffer,NumBytes,pBytesWritten

	invoke WriteFile,[hFile],[pBuffer],[NumBytes],[pBytesWritten],0
	xor		eax,1
	ret

ENDF

StartEventViewer FRAME lParam
	LOCAL sei			:SHELLEXECUTEINFO
	LOCAL RegExitCode	:D

	invoke EnableWindow,[lParam],FALSE

	mov D[sei.cbSize],SIZEOF SHELLEXECUTEINFO
	mov D[sei.fMask],SEE_MASK_NOCLOSEPROCESS
	mov eax,[lParam]
	mov [sei.hwnd],eax
	push "open"
	pop [sei.lpVerb]
	push "eventvwr.msc"
	pop [sei.lpFile]
	mov D[sei.lpParameters],NULL
	mov D[sei.lpDirectory],NULL
	mov D[sei.nShow],SW_SHOW

	invoke ShellExecuteEx,OFFSET sei
	or eax,eax
	jz >.EXIT

	cmp D[sei.hProcess],0
	je >.EXIT
		invoke WaitForSingleObject,[sei.hProcess],INFINITE
		invoke CloseHandle,[sei.hProcess]
	.EXIT
	invoke EnableWindow,[lParam],TRUE
	invoke SetForegroundWindow,[lParam]

	RET
ENDF

StartDrWatson FRAME lParam
	LOCAL pi			:PROCESS_INFORMATION
	LOCAL sui			:STARTUPINFO
	LOCAL RegExitCode	:D

	invoke EnableWindow,[lParam],FALSE

	mov D[sui.cb],SIZEOF STARTUPINFO
	invoke GetStartupInfo,OFFSET sui
	invoke CreateProcess,OFFSET DrWatMain,OFFSET DrWatConfig,NULL,NULL,\
		TRUE,NULL,NULL,NULL,OFFSET sui,OFFSET pi
	or eax,eax
	jz >.EXIT
		invoke WaitForSingleObject,[pi.hProcess],INFINITE
		invoke CloseHandle,[pi.hProcess]
		invoke CloseHandle,[pi.hThread]
	.EXIT
	invoke EnableWindow,[lParam],TRUE
	invoke SetForegroundWindow,[lParam]

	RET
ENDF

SaveFile FRAME lpFileName
	LOCAL	hFile:D
	LOCAL	editstream:EDITSTREAM

	invoke CreateFile,[lpFileName],GENERIC_WRITE,FILE_SHARE_READ,NULL,\
		CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	or eax,eax
	js >
		mov		[hFile],eax
		;stream the text to the file
		mov		[editstream.dwCookie],eax
		mov		[editstream.pfnCallback],offset StreamOutProc
		invoke SendMessage,[hREd],EM_STREAMOUT,SF_TEXT,addr editstream
		invoke CloseHandle,[hFile]
		;Set the modify state to false
		invoke SendMessage,[hREd],EM_SETMODIFY,FALSE,0
   		mov		eax,FALSE
   		ret
   	:
		invoke MessageBox,[hWnd],offset SaveFileFail,offset AppName,MB_OK
		mov		eax,TRUE
	ret
ENDF

SaveEditAs FRAME
	LOCAL	ofn					:OPENFILENAME
	LOCAL	buffer[MAX_PATH]	:B

	;Zero out the ofn struct
    invoke RtlZeroMemory,addr ofn,sizeof OPENFILENAME
	;Setup the ofn struct
	mov D[ofn.lStructSize],sizeof OPENFILENAME
	push [hWnd]
	pop [ofn.hwndOwner]
	push [hInstance]
	pop [ofn.hInstance]
	mov D[ofn.lpstrFilter],NULL
	mov B[buffer],0
	lea eax,buffer
	mov [ofn.lpstrFile],eax
	mov D[ofn.nMaxFile],MAX_PATH
	mov D[ofn.Flags],OFN_FILEMUSTEXIST+OFN_HIDEREADONLY+\
			OFN_PATHMUSTEXIST+OFN_OVERWRITEPROMPT
    mov D[ofn.lpstrDefExt],NULL
    ;Show save as dialog
	invoke GetSaveFileName,addr ofn
	or eax,eax
	jz >L1
		invoke SaveFile,addr buffer
		or eax,eax
		jnz >L2
			;The file was saved
			invoke lstrcpy,offset FileName,addr buffer
		;	invoke SetWinCaption
			mov eax,FALSE
			ret
	L1:
		mov	eax,TRUE
	L2:
		ret

ENDF
